

PrintWriter output;  

PImage photo; 

float smallifier = 2.5; 

void setup()  
{  
  smooth();  
  photo = loadImage("scarlett-johansson-1-1_thresh.png"); 
  size((int)(photo.width), (int)(photo.height));  
  output = createWriter("output.g"); 
  background(255);


  output.println("G21");
  output.println("G90");
  output.println("G0");

  output.println("Z+2");

  drawCircles2(photo, 5); 
  save("output.png"); 
  output.flush();  
  output.close();  

}  

void draw() 
{  
  //nothing to do here
}  


void drawCircles2(PImage photo, int spacing) 
{
  int holes=0;
  int lastI=0;
  int lastJ=0;

  int largestJ =0;
  int largestI =0;

  for(int j = 0; j < photo.height; j+=spacing)  
  {
    for(int i = 0; i < photo.width; i+=spacing) 
    {
      PImage segment = photo.get(i, j, spacing, spacing); 
      float brighnezz = getAreaBrightness(segment); 
      float cSize =( (255-brighnezz)/30.2); 

      if(cSize >2.0) 
      {
        fill(0); 
        stroke(0); 

        output.println("G0Y"+j/smallifier+"X"+i/smallifier);
        output.println("Z-4");
        output.println("Z+4");
        lastI=i;
        lastJ=j;
        holes++;

        if(j>largestJ)
          largestJ=j;
        if(i>largestI)
          largestI=i;

        ellipse(i, j,1.0, 1.0);
      }
    }
  }

  println("(Y) largestJ = "+largestJ/smallifier);
  println("(X) largestI = "+largestI/smallifier);

  println("holes = "+holes);
}   

float getAreaBrightness(PImage area)
{
  int bval = 0, count = 1;

  for(int i = 0; i < area.width; i++)
  {
    for(int j = 0; j < area.height; j++)
    {
      color check = area.get(i, j); 

      bval += brightness(check); //thank you processign for having all the tedious task's as functions!
      count++;
    }
  }
  return (bval/count);
}










